package com.example.catchme;

import android.annotation.SuppressLint;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.LinearLayoutCompat;

import android.content.Context;
import android.content.Intent;
import android.graphics.Point;
import android.graphics.drawable.Drawable;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.Display;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowInsets;
import android.widget.AbsoluteLayout;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TableRow;
import android.widget.TextView;

import com.example.catchme.databinding.ActivityGameBinding;

import java.util.LinkedList;
import java.util.Random;

/**
 * An example full-screen activity that shows and hides the system UI (i.e.
 * status bar and navigation/system bar) with user interaction.
 */
public class GameActivity extends AppCompatActivity implements SensorEventListener {
    /**
     * Whether or not the system UI should be auto-hidden after
     * {@link #AUTO_HIDE_DELAY_MILLIS} milliseconds.
     */
    private static final boolean AUTO_HIDE = true;

    /**
     * If {@link #AUTO_HIDE} is set, the number of milliseconds to wait after
     * user interaction before hiding the system UI.
     */
    private static final int AUTO_HIDE_DELAY_MILLIS = 3000;

    /**
     * Some older devices needs a small delay between UI widget updates
     * and a change of the status and navigation bar.
     */
    private static final int UI_ANIMATION_DELAY = 300;

    private View mContentView;
    private View mControlsView;
    private boolean mVisible;
    private ActivityGameBinding binding;



    //accelerometer
    private SensorManager sensorManager;
    private Sensor sensor;
    public static final String ACTIVITY_RECOGNITION = "android.permission.ACTIVITY_RECOGNITION";


    private ImageView hunterImage;
    private ImageView targetImage;
    private ImageView resultImage;
    private Drawable imageTarget;

    private  TextView information;

    private int width;
    private int height;
    private int currentscore=0;
    private String nickname="";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        binding = ActivityGameBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());

        mVisible = true;
        mControlsView = binding.fullscreenContentControls;
        mContentView = binding.fullscreenContent;

        // Set up the user interaction to manually show or hide the system UI.
        mContentView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                toggle();
            }
        });

        // Upon interacting with UI controls, delay any scheduled hide()
        // operations to prevent the jarring behavior of controls going away
        // while interacting with the UI.
        binding.dummyButton.setOnTouchListener(mDelayHideTouchListener);




        //receive parameters and print them
        Intent home = getIntent();
        nickname = home.getStringExtra("nickname");
        String target = home.getStringExtra("target");
        String hunter = home.getStringExtra("hunter");
        String result = home.getStringExtra("result");
        String sound = home.getStringExtra("sound");



        //get screen's height and width
        Display display = getWindowManager().getDefaultDisplay();
        Point size = new Point();
        display.getSize(size);
        width=size.x;
        height=size.y;


        information = findViewById(R.id.fullscreen_content);
        information.setText(nickname+"\n"+"highscore\n"+currentscore);


        //sensor
        sensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);
        sensor = sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);

        //if sensor is not null
        if (sensor != null) {
            //assign images
            hunterImage = findViewById(R.id.hunter_image);
            chooseImage(hunterImage, hunter);

            targetImage = findViewById(R.id.target_image);
            chooseImage(targetImage, target);
            setImageViewPosition(targetImage, width/2, height/2 );

            int a[] ={(int)targetImage.getX(), (int)targetImage.getY()};
            points.add(a);
            //targetImage.setVisibility(View.INVISIBLE);

            imageTarget = targetImage.getDrawable();

            resultImage = findViewById(R.id.result_image);
            chooseImage(resultImage, result);
            resultImage.setVisibility(View.INVISIBLE);



        }

    }


    @Override
    protected void onResume() {
        super.onResume();
        sensorManager.registerListener(this, sensor,
                SensorManager.SENSOR_DELAY_GAME);

    }

    @Override
    protected void onPause() {
        super.onPause();
        sensorManager.unregisterListener(this);
    }

    /*
    public void onSensorChanged(SensorEvent event){
        // In this example, alpha is calculated as t / (t + dT),
        // where t is the low-pass filter's time-constant and
        // dT is the event delivery rate.

        final float alpha = 0.8f;

        // Isolate the force of gravity with the low-pass filter.
        gravity[0] = alpha * gravity[0] + (1 - alpha) * event.values[0];
        gravity[1] = alpha * gravity[1] + (1 - alpha) * event.values[1];
        gravity[2] = alpha * gravity[2] + (1 - alpha) * event.values[2];

        // Remove the gravity contribution with the high-pass filter.
        linear_acceleration[0] = event.values[0] - gravity[0];
        linear_acceleration[1] = event.values[1] - gravity[1];
        linear_acceleration[2] = event.values[2] - gravity[2];
    }*/


    @Override
    protected void onPostCreate(Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);

        // Trigger the initial hide() shortly after the activity has been
        // created, to briefly hint to the user that UI controls
        // are available.
        delayedHide(100);
    }

    /**
     * Touch listener to use for in-layout UI controls to delay hiding the
     * system UI. This is to prevent the jarring behavior of controls going away
     * while interacting with activity UI.
     */
    private final View.OnTouchListener mDelayHideTouchListener = new View.OnTouchListener() {
        @Override
        public boolean onTouch(View view, MotionEvent motionEvent) {
            switch (motionEvent.getAction()) {
                case MotionEvent.ACTION_DOWN:
                    if (AUTO_HIDE) {
                        delayedHide(AUTO_HIDE_DELAY_MILLIS);
                    }
                    break;
                case MotionEvent.ACTION_UP:
                    view.performClick();
                    break;
                default:
                    break;
            }
            return false;
        }
    };

    private void toggle() {
        if (mVisible) {
            hide();
        } else {
            show();
        }
    }

    private void hide() {
        // Hide UI first
        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null) {
            actionBar.hide();
        }
        mControlsView.setVisibility(View.GONE);
        mVisible = false;

        // Schedule a runnable to remove the status and navigation bar after a delay
        mHideHandler.removeCallbacks(mShowPart2Runnable);
        mHideHandler.postDelayed(mHidePart2Runnable, UI_ANIMATION_DELAY);
    }

    private final Runnable mHidePart2Runnable = new Runnable() {
        @SuppressLint("InlinedApi")
        @Override
        public void run() {
            // Delayed removal of status and navigation bar
            if (Build.VERSION.SDK_INT >= 30) {
                mContentView.getWindowInsetsController().hide(
                        WindowInsets.Type.statusBars() | WindowInsets.Type.navigationBars());
            } else {
                // Note that some of these constants are new as of API 16 (Jelly Bean)
                // and API 19 (KitKat). It is safe to use them, as they are inlined
                // at compile-time and do nothing on earlier devices.
                mContentView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_LOW_PROFILE
                        | View.SYSTEM_UI_FLAG_FULLSCREEN
                        | View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                        | View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY
                        | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                        | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION);
            }
        }
    };

    private void show() {
        // Show the system bar
        if (Build.VERSION.SDK_INT >= 30) {
            mContentView.getWindowInsetsController().show(
                    WindowInsets.Type.statusBars() | WindowInsets.Type.navigationBars());
        } else {
            mContentView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                    | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION);
        }
        mVisible = true;

        // Schedule a runnable to display UI elements after a delay
        mHideHandler.removeCallbacks(mHidePart2Runnable);
        mHideHandler.postDelayed(mShowPart2Runnable, UI_ANIMATION_DELAY);
    }

    private final Runnable mShowPart2Runnable = new Runnable() {
        @Override
        public void run() {
            // Delayed display of UI elements
            ActionBar actionBar = getSupportActionBar();
            if (actionBar != null) {
                actionBar.show();
            }
            mControlsView.setVisibility(View.VISIBLE);
        }
    };

    private final Handler mHideHandler = new Handler();
    private final Runnable mHideRunnable = new Runnable() {
        @Override
        public void run() {
            hide();
        }
    };

    /**
     * Schedules a call to hide() in delay milliseconds, canceling any
     * previously scheduled calls.
     */
    private void delayedHide(int delayMillis) {
        mHideHandler.removeCallbacks(mHideRunnable);
        mHideHandler.postDelayed(mHideRunnable, delayMillis);
    }




    public static int x = 0;
    public static int y = 0;

    @Override
    public void onSensorChanged(SensorEvent se) {
        float xacc = se.values[0];
        float yacc = se.values[1];
        float zacc = se.values[2];


        x -= (int) se.values[0];
        y += (int) se.values[1];




        preventOffScrenn(hunterImage);

        hunterImage.setX(x);
        hunterImage.setY(y);


        if (passage) passage=false;


        hunting();

        gameOver();

    }


    //go to hunt
    boolean passage=false;
    LinkedList<int[]> points = new LinkedList<>();


    public void hunting(){

        double distance = Math.sqrt(Math.pow(targetImage.getX() - hunterImage.getX(), 2) + Math.pow(targetImage.getY() - hunterImage.getY(), 2));




        if(distance <= targetImage.getHeight()-5 && !passage) {
            ImageView newTarget =new ImageView(this);
            newTarget.setImageDrawable(imageTarget);
            TableRow.LayoutParams layoutParams = new TableRow.LayoutParams(hunterImage.getWidth(), hunterImage.getHeight());
            newTarget.setLayoutParams(layoutParams);
            int x= (0 + (int)(Math.random() * (((width - targetImage.getWidth()) - 0) + 1)));
            int y= (0 + (int)(Math.random() * (((height -targetImage.getHeight() )- 0) + 1)));
            newTarget.setX(x);
            newTarget.setY(y);

            targetImage.setImageDrawable(resultImage.getDrawable());
            FrameLayout f=findViewById(R.id.frame_layout);
            f.addView(newTarget);
            information.setText(nickname+"\n"+"highscore\n"+(currentscore+=5));
            targetImage=newTarget;
            passage=true;

            //add point
            int[] p= {x, y};
            points.add(p);
        }

    }

    //
    public void gameOver(){
        for(int i=0; i < points.size()-2; i++){
            if(Math.sqrt(Math.pow(points.get(i)[0] - hunterImage.getX(), 2) + Math.pow(points.get(i)[1] - hunterImage.getY(), 2)) <= targetImage.getHeight()-5){
                //information.setText(nickname+"\n"+"highscore\nGameOver");
                //receive parameters and print them
                Intent home = getIntent();
                nickname = home.getStringExtra("nickname");
                String target = home.getStringExtra("target");
                String hunter = home.getStringExtra("hunter");
                String result = home.getStringExtra("result");
                String sound = home.getStringExtra("sound");


                Intent goScore =new Intent(this, ScoreActivity.class);
                goScore.putExtra("nickname", nickname);
                goScore.putExtra("score", String.valueOf(currentscore));
                goScore.putExtra("target",target);
                goScore.putExtra("hunter",hunter);
                goScore.putExtra("result",result);
                goScore.putExtra("sound", sound);


                startActivityForResult(goScore, 40);
            }
        }

    }


    /*public LinkedList<float[]> getAllPossiblePoints(){

        for(){

        }
    }*/

    public void chooseImage(ImageView image, String s){
        switch (s){
            case "Mouse": {image.setImageResource(R.drawable.mouse);break;}
            case "Cat": {image.setImageResource(R.drawable.cat);break;}
            case "Blood": {image.setImageResource(R.drawable.blood);break;}
            case "Police": {image.setImageResource(R.drawable.police);break;}
            case "Thief": {image.setImageResource(R.drawable.thief);break;}
            case "Jail": {image.setImageResource(R.drawable.jail);break;}
        }

    }


    public void setImageViewPosition(ImageView image, float x, float y){

        image.setX(x);
        image.setY(y);
    }




    @Override
    public void onAccuracyChanged(Sensor sensor, int accuracy) {

    }


    public void preventOffScrenn(View v) {


        if (x > width - (int) v.getMeasuredWidth() / 2) {
            x = width - (int) v.getMeasuredWidth() / 2;
        }

        if (x < -(int) v.getMeasuredWidth() / 2) {
            x = -(int) v.getMeasuredWidth() / 2;
        }

        if (y > height - (int) v.getMeasuredHeight() / 2) {
            y = height - (int) v.getMeasuredHeight() / 2;
        }

        if (y < -(int) v.getMeasuredHeight() / 2) {
            y = -(int) v.getMeasuredHeight() / 2;
        }
    }





}