package com.example.catchme;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

public class GameParameterActivity extends AppCompatActivity implements AdapterView.OnItemSelectedListener {

    Spinner targetSpinner, hunterSpinner, resultSpinner, soundSpinner;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_game_parameter);

        // Create an ArrayAdapter using the string array and a default spinner layout
        ArrayAdapter<CharSequence> adapterShapes = ArrayAdapter.createFromResource(this,
                R.array.spinner_shapes, android.R.layout.simple_spinner_item);

        targetSpinner = findViewById(R.id.targetSpinner);
        spinnerParameters(targetSpinner, adapterShapes);

        hunterSpinner = findViewById(R.id.hunterSpinner);
        spinnerParameters(hunterSpinner, adapterShapes);

        resultSpinner = findViewById(R.id.resultSpinner);
        spinnerParameters(resultSpinner, adapterShapes);

        // Create an ArrayAdapter using the string array and a default spinner layout
        ArrayAdapter<CharSequence> adapterSounds = ArrayAdapter.createFromResource(this,
                R.array.spinner_sounds, android.R.layout.simple_spinner_item);

        soundSpinner = findViewById(R.id.soundSpinner);
        spinnerParameters(soundSpinner, adapterSounds);




    }

    public void validate(View v){
        Intent homeIntent =new Intent(this, HomeActivity.class);

        //get nickname
        EditText nicknameEditText = findViewById(R.id.nickname);
        String nickname = nicknameEditText.getText().toString();

        //get target spinner value
        //Spinner targetSpinner= findViewById(R.id.targetSpinner);
        String target = targetSpinner.getSelectedItem().toString();

        //get hunter spinner value
        String hunter = hunterSpinner.getSelectedItem().toString();

        //get result spinner value
        String result = resultSpinner.getSelectedItem().toString();

        //get sound spinner value
        String sound = soundSpinner.getSelectedItem().toString();

        //if nickname is not empty then send all the data to home activity
        if(nickname.length() > 0){

            homeIntent.putExtra("nickname",nickname);
            homeIntent.putExtra("target",target);
            homeIntent.putExtra("hunter",hunter);
            homeIntent.putExtra("result",result);
            homeIntent.putExtra("sound",sound);

            //startActivity(homeIntent);
            startActivityForResult(homeIntent, 1);

        }else{
            Toast.makeText(getApplicationContext(),
                    "Please enter your name!",
                    Toast.LENGTH_LONG)
                    .show();
        }

    }


    public void spinnerParameters(Spinner spinner, ArrayAdapter<CharSequence> adapter){
        // Take the instance of Spinner and
        // apply OnItemSelectedListener on it which
        // tells which item of spinner is clicked
        spinner.setOnItemSelectedListener(this);


        // Specify the layout to use when the list of choices appears
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        // Apply the adapter to the spinner
        spinner.setAdapter(adapter);

    }


    public void onItemSelected(AdapterView<?> parent, View view,
                               int pos, long id) {
        // make toastof name of course
        // which is selected in spinner
        /*Toast.makeText(getApplicationContext(),
                getResources().getStringArray(R.array.spinner_shapes)[pos],
                Toast.LENGTH_LONG)
                .show();*/
    }

    public void onNothingSelected(AdapterView<?> parent) {
        // Another interface callback
    }


}